#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <GL/glut.h>

#include "GLUtility.h"

static const int DefaultRandRange = 3;
 
static int randInt(int low, int high)
{
    // Random number between low and high
    return rand() % ((high + 1) - low) + low;
}

GLUtility::GLUtility(int numPts) :
    curLinePts_(numPts)
{
    srand(time(NULL));
}


GLUtility::~GLUtility()
{
    clearLines();
}


void
GLUtility::createRandomLine()
{
    // Create a random line and add
    double *verts = new double[curLinePts_ * 3];
    for (unsigned int i = 0; i < curLinePts_; ++i) {
        double val1 = randInt(-DefaultRandRange, DefaultRandRange) / 10.0f;
        double val2 = randInt(-DefaultRandRange, DefaultRandRange) / 10.0f;
        double val3 = randInt(-DefaultRandRange, DefaultRandRange) / 10.0f;
        int c = i * 3;
        verts[c] = val1;
        verts[c + 1] = val2;
        verts[c + 2] = val3;
    }
    lineList_.push_back(vertArray(verts, curLinePts_));
}


void
GLUtility::clearLines()
{
    std::vector<vertArray>::iterator iter = lineList_.begin();
    for (; iter != lineList_.end(); ++iter) {
        vertArray tmp = *iter;
        delete [] tmp.first;
    }
    lineList_.clear();
}
